#ifndef INTARRAY_HPP
#define INTARRAY_HPP

#include "List.hpp"


class IntArray : public List{
	public:
		int mSize;
		int *mArray;
		
	IntArray(int *array, int size);	
	int indexOf(const int value);

	/* Removes an item at position index by shifting later elements left.
	 * Returns true iff 0 <= index < size.
	 */
	bool remove(const int index);

	/* Insert the integer val at position pos */
	void insert(const int pos, const int val);

	/* Retrieves the element at position pos */
	int get(const int pos) const;

	/* Sets the element at position pos to the value val.*/
	int set(const int pos, const int val);

	/* Returns if the two lists contain the same elements in the
	 * same order.
	 */
	bool equals(const List &list);
	
	~IntArray();
			
};

#endif
