/* Array is templated, therefore only include the code if it is included from
 * the header file! 
 */
#ifdef ARRAY_H
#include <stdio.h>

/* Do a deep copy of the array into the list.
 * Note: This one uses a pointer!
 */
template <class T>
Array<T>::Array(const T *array, const int size){
	mSize = size;
	mArray = new T[size];
	
	for (int i =0; i < mSize; i++) {
		 mArray[i] = array[i];
	}
}

/* Do a deep copy of the array into the list
 * Note: This one uses a reference to a List!
 */
template <class T>
Array<T>::Array(const Array<T> &list){
	
}

template <class T>
int Array<T>::getLength() const {
	return mSize;
}

	/* Returns the index in the array where value is found.  
	 * Return -1 if value is not present in the array.
	 */
template <class T>	
int Array<T>::indexOf(const T &value) {
	int index = 0;
		
	for (int i = 0; i < mSize; i++) {
		if ( mArray[i] == value ) {
			index = i;
			return index;
		}
	}
	return -1;
}

	/* Removes an item at position index by shifting later elements left.
	 * Returns true iff 0 <= index < size.
	 */
template <class T>	
bool Array<T>::remove(const int index) {
	for (int i = 0; i < mSize; i++) { 
		if (mArray[i] == index) { 
			for (int j = i; j < mSize - 1; j++) { 
				mArray[j] = mArray[j + 1]; 
			}
			mSize--; 
			return true; 
		}
	}
	return false;
}


/* Retrieves the element at position pos */
template <class T>
T& Array<T>::operator[](const int pos){
	return mArray[pos];
}

template <class T>
bool Array<T>::operator==(Array<T> &list) const {
	for (int i = 0; i < mSize; i++) {
		if (mArray[i] == list[i]) {
			return true;
		}
	}
	return false;
}

template <class T>
Array<T>::~Array() {
	delete[] mArray;
}

#endif
