#ifndef DLLIST_HPP
#define DLLIST_HPP

template<class T>
class DLList {
private:
    /* Class exercise to fill in. */
      class Node {
        public:
            T mData;
            Node *mNext;
    };

    Node *mHead, *mTail;
    int mSize; 
public:
    /* Empty constructor shall create an empty Linked List! */
    DLList();
    /* Do a deep copy of dll into the this.
     * Note: This one uses a reference to a Singly Linked List!
     */
    DLList(const DLList<T> &dll);
    /* Deconstructor shall free up memory */
    ~DLList();
    /* Return the current length of the Singly Linked List */
    int getLength() const;
    /* Insert at the end of the list.*/
    bool append(const T &val);
    /* Insert val at position pos.
     * Return true if successful (it can be placed.)
     * Otherwise return false.
     */
    bool insert(const int pos, const T &val);
    /* Print out the Singly Linked List */
    void print() const;
    /* Remove the first instance of val
     * Return true if found and removed.
     * Otherwise return false.
     */
    bool remove(const T &val);
    /* Retrieves the element at position pos */
    
    T& operator[](const int pos);
    /* Returns if the two lists contain the same elements in the
     * same order.
     */
    bool operator==(const DLList<T> &list) const;
    
};

#include "sllist.cpp"

#endif
