//
// dllist.hpp
// Created by Isiah Johnson on 9/25/17.

#ifndef _dllist_hpp_
#define _dllist_hpp_

/* DLL = Doubly Linked List */ 
template<class T> 
class DLList {
private:
/* Class exercise to fill in. */ 

	DLLNode() { 
		mNext = mPrev = 0; 
		mHead = mTail =0;
		}
	
	 T mVal;
	DLLNode *mNext;
	DLLNode *mPrev;
	
	int mSize;
	DLLNode *mHead;	
	DLLNode *mTail;
	
public:
/* Empty constructor shall create an empty Linked List! */ 
	DLList();

/* Do a deep copy of dll into the this.
* Note: This one uses a reference to a Singly Linked List! */ 
	DLList(const DLList<T> &dll);

/* Deconstructor shall free up memory */ 
	~DLList();

/* Return the current length of the Singly Linked List */ 
	int getLength() const;

/* Insert at the end of the list.*/ 
	bool append(const T &val);

/* Insert val at position pos.
* Return true if successful (it can be placed.) * Otherwise return false.
*/ 
	bool insert(const int pos, const T &val);

/* Print out the Singly Linked List */ 
	void print() const;

/* Remove the first instance of val * Return true if found and removed. * Otherwise return false.
*/ 
	bool remove(const T &val);

/* Retrieves the element at position pos */

	T& operator[](const int pos);

/* Returns if the two lists contain the same elements in the * same order.

*/ 
	bool operator==(const DLList<T> &list) const;

};

#include "dllist.cpp"

#endif