/* Array is templated, therefore only include the code if it is included from
 * the header file! 
 */
#ifdef ARRAY_H
#include <stdio.h>

/* Do a deep copy of the array into the list.
 * Note: This one uses a pointer!
 */
template <class T>
Array<T>::Array(const T *array, const int size) {
	mSize = size;
	mArray = new T[size];
		
	for (int i =0; i < mSize; i++) {
		mArray[i] = array[i];
	}

}

/* Do a deep copy of the array into the list
 * Note: This one uses a reference to a List!
 */
template <class T>
Array<T>::Array(const Array<T> &list) {
}

/* Return the current length of the array */
template <class T>
int Array<T>::getLength() const {
	return mSize;
}

/* Returns the index in the array where value is found.  
 * Return -1 if value is not present in the array.
 */
template <class T>
int Array<T>::search(const T &value) {
	for (int index =0; index < mSize; index++) {
		if (mArray[index] == value) {
			return index;
		}
	}
	return -1;
}

/* Removes an item at position index by shifting later elements left.
 * Returns true iff 0 <= index < size.
 */
template <class T>
bool Array<T>::remove(const int index) {
	
}


/* Returns if the two lists contain the same elements in the
 * same order.
 */
template <class T>
bool Array<T>::operator==(Array<T> &list) const {
	
}

/* Runs a bubble sort algorithm on the array.
 * The array shall be ordered from least to greatest
 */
template <class T>
void Array<T>::bubbleSort() {
	bool sortcheck = true;
	 int j=1,tmp; 
 
 	while (sortcheck)  {
 		sortcheck = false;
	 	j++;
 		for (int i = 0; i < mSize - j; i++) {
 			if (mArray[i] > mArray[i + 1]) {
 				tmp = mArray[i];
		 		mArray[i] = mArray[i + 1];
		 		mArray[i + 1] = tmp;
 				sortcheck = true;	
			}
		}
 	}	
}

/* Searches for an element with value value and returns the index of that
 * data.
 * NOTE: We assume the array is sorted!
 * Return -1 if the value is not found.
 */
template <class T>
int Array<T>::binarySearch(const T &value) {
	for (int index = 0; index < mSize; index++) {
		if (mArray[index] == value) {
			return index;
		}		
	}
	return -1;
}

/* Free any memory used! */


/* Retrieves the element at position pos */
template <class T>
T& Array<T>::operator[](const int pos) {
	
}

template <class T>
Array<T>::~Array() {
	delete mArray;
}

#endif
