#ifdef ARRAY_H
#include <stdio.h>
#include <iostream>

using namespace std;

template <class T>
Array<T>::Array(const T *array, const int size) {
        mSize = size;
        mArray = new T[size];
        
        for (int i =0; i < mSize; i++) {
             mArray[i] = array[i];
        }
}

    /* Do a deep copy of the array into the list
     * Note: This one uses a reference to a List!
     */
template <class T>
Array<T>::Array(const Array<T> &list) {
        
}

/* Return the current length of the array */
template <class T> 
int Array<T>::getLength() const {
        return mArray[mSize];
}

    /* Returns the index in the array where value is found.  
     * Return -1 if value is not present in the array.
     */
template <class T>
int Array<T>::indexOf(const T &value) {
        int index = 0;
            
            for (int i = 0; i < mSize; i++) {
                if (mArray[i] == value) {
                    index = i;
                    return index;
                        }
            }
            return -1;
}

    /* Removes an item at position index by shifting later elements left.
     * Returns true iff 0 <= index < size.
     */
template <class T>
bool Array<T>::remove(const int index) {
    for (int i = 0; i < mSize; i++) { 
            if (mArray[i] == index) { 
                for (int j = i; j < mSize - 1; j++) { 
                        mArray[j] = mArray[j + 1]; 
                }
                mSize--; 
                return true; 
        }
    }
    return false;        
}

    /* Retrieves the element at position pos */
template <class T>
T& Array<T>::operator[](const int pos) {
        
}

    /* Returns if the two lists contain the same elements in the
     * same order.
     */
template <class T>
bool Array<T>::operator==(Array<T> &list) const {
    for (int i = 0; i < mSize; i++) {
            if (mArray[i] == list[i]) {
                return true;
            }
    }
    return false;
}

    /* Perform a merge sort. */
template <class T>
void Array<T>::msort() {
        int size = mSize;
        T *temp;
        
        //Recursive
        if (size == 1) {
            return;
        }

        int middlePos = mSize / 2;
        msort(mArray, middlePos);
        if (size % 2 == 0) { // size is even
            msort(mArray + middlePos, middlePos);
        }else {
            msort(mArray + middlePos, middlePos + 1);
        }

        // We need to merge!
        int s1pos = 0;
        int s2pos = middlePos;
        int pos = 0;

        for (pos = 0; pos < size; pos++) {
            if ((s2pos >= size) || (s1pos < middlePos && mArray[s1pos] < mArray[s2pos])) {
                temp[pos] = mArray[s1pos];
                s1pos++;
            } else {
                temp[pos] = mArray[s2pos];
                s2pos++;
            }
        }

        for (int i = 0; i < size; i++) {
            mArray[i] = temp[i];
        }
}

    /* Perform a quick sort. */
template <class T>
void Array<T>::qsort() {
    int first = mArray[0];
    int last = mArray[mSize];
    
    int lower = first+1, upper = last;
    swap(mArray[first],mArray[(first+last)/2]); 
    T pivot = mArray[first]; 
    while (lower <= upper) { 
        while (pivot > mArray[lower]) 
            lower++; 
        while (pivot < mArray[upper]) 
            upper--;
        if (lower < upper)
         swap(mArray[lower++],mArray[upper--]);
         else lower++;

} 
swap(mArray[upper],mArray[first]); 
if (first < upper-1)
    qsort (mArray,first,upper-1); 
if (upper+1 < last)
    qsort (mArray,upper+1,last);   
}

    /* Perform the sort you believe is best. */
template <class T>
void Array<T>::sort() {
        
}

    /* Free any memory used! */
template <class T>
Array<T>::~Array() {
    delete mArray, mSize;
};


#endif
